commit 2829e221b0cd89eccf1c553f1bc5c1b87aba1232
Author: freddy77 <freddy77>
Date:   Thu May 21 16:41:27 2009 +0000

    support wchar -> binary conversions

diff --git a/ChangeLog b/ChangeLog
index 1a59002..7892c24 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu May 21 18:41:21 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/prepare_query.c src/odbc/unittests/blob1.c:
+	- support wchar -> binary conversions
+
 Thu May 21 18:39:31 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsconvert.h src/odbc/prepare_query.c src/tds/convert.c:
 	- extract and reuse tds_char2hex
@@ -1566,4 +1570,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2793 2009/05/21 16:39:37 freddy77 Exp $
+$Id: ChangeLog,v 1.2794 2009/05/21 16:41:27 freddy77 Exp $
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index b41fae9..418513c 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.76 2009/05/21 16:39:38 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.77 2009/05/21 16:41:27 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -243,6 +243,48 @@ start_parse_prepared_query(struct _hstmt *stmt, int compute_row)
 	return parse_prepared_query(stmt, compute_row);
 }
 
+static TDS_INT
+odbc_wchar2hex(TDS_CHAR *dest, TDS_UINT destlen, const SQLWCHAR * src, TDS_UINT srclen)
+{
+	unsigned int i;
+	SQLWCHAR hex1, c = 0;
+
+	/* if srclen if odd we must add a "0" before ... */
+	i = 0;		/* number where to start converting */
+	if (srclen & 1) {
+		++srclen;
+		i = 1;
+		--src;
+	}
+	for (; i < srclen; ++i) {
+		hex1 = src[i];
+
+		if ('0' <= hex1 && hex1 <= '9')
+			hex1 &= 0x0f;
+		else {
+			hex1 &= (SQLWCHAR) ~0x20u;	/* mask off 0x20 to ensure upper case */
+			if ('A' <= hex1 && hex1 <= 'F') {
+				hex1 -= ('A' - 10);
+			} else {
+				tdsdump_log(TDS_DBG_INFO1,
+					    "error_handler:  attempt to convert data stopped by syntax error in source field \n");
+				return TDS_CONVERT_SYNTAX;
+			}
+		}
+		assert(hex1 < 0x10);
+
+		if ((i/2u) >= destlen)
+			continue;
+
+		if (i & 1)
+			dest[i / 2u] = c | hex1;
+		else
+			c = hex1 << 4;
+	}
+	return srclen / 2u;
+}
+
+
 int
 continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN StrLen_or_Ind)
 {
@@ -327,7 +369,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 		int binary_convert = 0;
 		SQLLEN orig_len;
 
-		if (sql_src_type == SQL_C_CHAR) {
+		if (sql_src_type == SQL_C_CHAR || sql_src_type == SQL_C_WCHAR) {
 			switch (tds_get_conversion_type(curcol->column_type, curcol->column_size)) {
 			case SYBBINARY:
 			case SYBVARBINARY:
@@ -335,9 +377,12 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 			case XSYBVARBINARY:
 			case SYBLONGBINARY:
 			case SYBIMAGE:
-				if (len && !*((char*)DataPtr+len-1))
+				if (len && sql_src_type == SQL_C_CHAR && !*((char*)DataPtr+len-1))
 					--len;
 
+				if (sql_src_type == SQL_C_WCHAR)
+					len /= sizeof(SQLWCHAR);
+
 				if (!len)
 					return SQL_SUCCESS;
 
@@ -368,27 +413,30 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 
 			if (curcol->column_cur_size > 0
 			&&  curcol->column_text_sqlputdatainfo) {
-				TDS_CHAR data[2];
+				SQLWCHAR data[2];
 				data[0] = curcol->column_text_sqlputdatainfo;
-				data[1] = *(char*)DataPtr;
+				data[1] = (sql_src_type == SQL_C_CHAR) ? *(unsigned char*)DataPtr : *(SQLWCHAR*)DataPtr;
 
-				res = tds_char2hex(p, 1, data, 2);
+				res = odbc_wchar2hex(p, 1, data, 2);
 				if (res < 0) {
 					odbc_convert_err_set(&stmt->errs, res);
 					return SQL_ERROR;
 				}
 				p += res;
 
-				DataPtr = (SQLPOINTER) (((char*)DataPtr) + 1);
+				DataPtr = (SQLPOINTER) (((char*)DataPtr) +
+					(sql_src_type == SQL_C_CHAR ? 1 : sizeof(SQLWCHAR)));
 				--len;
 			}
 
 			if (len&1) {
 				--len;
-				curcol->column_text_sqlputdatainfo = *((char*)DataPtr+len);
+				curcol->column_text_sqlputdatainfo = (sql_src_type == SQL_C_CHAR) ? ((char*)DataPtr)[len] : ((SQLWCHAR*)DataPtr)[len];
 			}
 
-			res = tds_char2hex(p, len / 2u, DataPtr, len);
+			res = (sql_src_type == SQL_C_CHAR) ?
+				tds_char2hex(p, len / 2u, DataPtr, len):
+				odbc_wchar2hex(p, len / 2u, DataPtr, len);
 			if (res < 0) {
 				odbc_convert_err_set(&stmt->errs, res);
 				return SQL_ERROR;
diff --git a/src/odbc/unittests/blob1.c b/src/odbc/unittests/blob1.c
index 038da59..04cd1e3 100755
--- a/src/odbc/unittests/blob1.c
+++ b/src/odbc/unittests/blob1.c
@@ -5,7 +5,7 @@
 #include <ctype.h>
 #include <assert.h>
 
-static char software_version[] = "$Id: blob1.c,v 1.18 2009/05/21 16:30:57 freddy77 Exp $";
+static char software_version[] = "$Id: blob1.c,v 1.19 2009/05/21 16:41:27 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define NBYTES 10000
@@ -133,7 +133,7 @@ from_sqlwchar(char *dst, const SQLWCHAR *src, int n)
 {
 	int i;
 	for (i = 0; i < n; ++i) {
-		assert(src[i] >= 0 && src[i] < 256);
+		assert(src[i] < 256);
 		dst[i] = src[i];
 	}
 	return n;
@@ -236,7 +236,7 @@ add_test(SQLSMALLINT c_type, SQLSMALLINT sql_type, const char *db_type, unsigned
 }
 
 static void
-free_tests()
+free_tests(void)
 {
 	while (num_tests > 0) {
 		test_info *t = &test_infos[--num_tests];

